Index: themes/jbds/html/root4.css
===================================================================
--- themes/jbds/html/root4.css	(revision 8351)
+++ themes/jbds/html/root4.css	(working copy)
@@ -1,17 +1,18 @@
 @charset "UTF-8";
 /* CSS Document */
+
+* html, html {
+	height: 100%;
+}
+
 body {
+	height: 100%;
 	margin:0;
 	padding:0;
 	text-align:center;
 	background:url(../graphics/root4page/welcome_bkg.png) #660000 no-repeat;
 }
 
-#root {
-	margin:0 auto;
-	text-align:left;
-}
-
 #header {
 	background:url(../graphics/root4page/header_bkg.png) repeat-x;
 	height:79px;	
@@ -19,8 +20,16 @@
 
 #welcome {
 	background:url(../graphics/root4page/welcome.png) no-repeat;
+	position:absolute;
+	top:0px;left:0px;
 	height:97px;
 	width:563px;
+	text-intent:-9999px;
+}
+
+#welcome a {
+	color:red;
+	display:block;
 }
 
 #welcome a .link-label {
@@ -67,25 +76,27 @@
 }
 
 #separator {
-	height: 70px;
+	height: 20px;
+	clear:both;
 }
 
 #icons {
 	padding:0px 0px;
-	margin:50px auto 0px auto;
+	margin:50px auto;
 	width:560px;
 	min-width:560px;
-	height:210px;
+	height:190px;
 
 	background-image:url(../graphics/root4page/icon_bkg.png);
     -moz-box-shadow: 4px 4px 4px #330000;
     -webkit-box-shadow: 4px 4px 4px #330000;
     box-shadow: 4px 4px 4px #330000;
-    /* For IE 8 */
+	<!--[if IE 8]>
     -ms-filter: "progid:DXImageTransform.Microsoft.Shadow(Strength=4, Direction=135, Color='#330000')";
-    /* For IE 5.5 - 7 */
-    filter: progid:DXImageTransform.Microsoft.Shadow(Strength=4, Direction=135, Color='#330000');
-	
+	<![endif]-->
+	<!--[if lte IE 7]> 
+    	filter: progid:DXImageTransform.Microsoft.Shadow(Strength=4, Direction=135, Color='#330000');
+	<![endif]-->
 }
 
 #icons a {
@@ -100,19 +111,6 @@
 	margin-bottom:20px;
 }
 
-#icons ul {
-	margin:0px;
-	padding:30px 0 10px 0px;	
-}
-#icons ul li {
-	list-style:none;
-	float:left;
-	width:405px;
-	min-width:405px;
-	height:446px;
-	padding:80px 0;
-}
-
 #icons-list {
 	margin: 30px 0;
 }
@@ -122,7 +120,7 @@
 	float:left;
 	width:405px;
 	min-width:405px;
-	height:300px;
+	height:190px;
 	padding:40px 0;
 	text-align:center;
 }
@@ -168,61 +166,19 @@
 	background-position:30px -110px !Important;
 }
 
-#separator {
-/*
-	display:block;
-	clear:both;
-*/
-}
-/*
-#getting-started a {
-	background: url(../graphics/root4page/icon-gettingstarted.png) no-repeat;
-	background-position: center -160px; 
-}
-*/
-#create-new a { 
-	background: url(../graphics/root4page/icon-createnew.png) no-repeat;
-	background-position: center -160px; 
-} 
-#perspectives a {
-	background: url(../graphics/root4page/icon-perspectives.png) no-repeat;
-	background-position: center -160px;
-}
-#web-resources a {
-	background: url(../graphics/root4page/icon-webresources.png) no-repeat;
-	background-position: center -160px; 
-}
-
-/*
-#getting-started a:hover{
-	background: url(../graphics/root4page/icon-gettingstarted.png) no-repeat;
-	background-position: center 0; 
-}
-*/
-#create-new a:hover{ 
-	background: url(../graphics/root4page/icon-createnew.png) no-repeat;
-	background-position: center 0; 
-} 
-#perspectives a:hover{
-	background: url(../graphics/root4page/icon-perspectives.png) no-repeat;
-	background-position: center 0;  
-}
-#web-resources a:hover{
-	background: url(../graphics/root4page/icon-webresources.png) no-repeat;
-	background-position: center 0; 
-}
-
 #footer {
-	background:url(../graphics/root4page/footer_bkg.png) repeat-x;	
+	background:url(../graphics/root4page/footer_bkg.png) repeat-x left 0px;	
+	position:absolute;
 	height:42px;
-	position:fixed;
 	bottom:0;
 	right:0;
-	padding-left:9999px;
+	padding-left:9999px; 
 	padding-top:29px;
 	z-index: 100; 
 }
 
+body>#footer {position: fixed;right:0px;left:auto;}
+
 #footer a .link-extra-div {
 	display :none;
 }
Index: intro4/introContent.xml
===================================================================
--- intro4/introContent.xml	(revision 8351)
+++ intro4/introContent.xml	(working copy)
@@ -29,31 +29,8 @@
 							id="getting-started" />
 					</group>
 				</group>
-				<!-- 
-				<group id="icons-list-item">
-					<group id="create-new">
-						<link style-id="content-link" label="$introTitle-createnew$" 
-							url="http://org.eclipse.ui.intro/showPage?id=createnew" 
-							id="create-new" />
-					</group>
-				</group>
-				<group id="icons-list-item">
-					<group id="perspectives">
-						<link style-id="content-link" label="$introTitle-perspectives$" 
-							url="http://org.eclipse.ui.intro/showPage?id=perspectives" 
-							id="perspectives" />
-					</group>
-				</group>
-				<group id="icons-list-item">
-					<group id="web-resources">
-						<link style-id="content-link" label="$introTitle-webresources$" 
-							url="http://org.eclipse.ui.intro/showPage?id=webresources" 
-							id="web-resources" />
-					</group>
-				</group>
-				-->
 			</group>
-			<!--  group id="separator" / -->
+			<group id="separator" />
        	</group>
 		
        	<group id="footer">